

// APT-generated file.

package org.carrot2.source.boss;

import java.util.*;
import javax.annotation.*;

// Imported for JavaDoc references mostly.
import org.carrot2.util.attribute.*;

/**
 * Metadata and attributes of the {@link org.carrot2.source.boss.BossImageSearchService} component. You can use 
 * this descriptor to obtain metadata, such as human readable name and description, about the component 
 * as a whole as well as about its attributes. Using the {@link #attributeBuilder(Map)}
 * you can obtain a builder for type-safe generation of the attribute maps. Please see the
 * <a href="{@docRoot}/overview-summary.html#setting-attributes">main overview</a> for a complete code example. 
 */
@Generated("Generated from org.carrot2.source.boss.BossImageSearchService")
public final class BossImageSearchServiceDescriptor implements IBindableDescriptor
{
    /**
     * The component class for which this descriptor was generated. 
     */
    public final String bindableClassName = "org.carrot2.source.boss.BossImageSearchService";

    /**
     * Attribute prefix used by the component.
     */
    public final String prefix = "BossImageSearchService";

    /**
     * A one sentence summary of the component. It could be presented as a header of the tool
     * tip of the corresponding UI component.
     */
    public final String title = "Sends queries to Yahoo! Boss Image search service";
    
    /**
     * A short label for the component. It can be presented as a label of the
     * corresponding UI component.
     */
    public final String label = "Yahoo Boss Image Search Service";

    /**
     * A longer, possibly multi sentence, description of the component. It could be presented
     * as a body of the tool tip of the corresponding UI component.
     */
    public final String description = "Instances of this class are thread-safe. <p> Attributes of this class correspond to Yahoo's documentation (see links below). Note the following service terms given by Yahoo: <b>You must:</b> <ol> <li>display the title or abstract of the image when presented in the search results; <li>display at least the first 40 characters of the referurl field which indicates the source page; <li>for the source page referurl, use the unmodified referclickurl field to navigate to the respective source page; <li>If the image is made clickable, either use unmodified refereclickurl (to the source HTML page) or clickurl (to the image) for the navigation link. </ol>";

    /**
     * Attributes of the component. Note that only statically reachable fields are included.
     * Additional attributes may be available at run time. 
     */
    public final static Attributes attributes; 

    /**
     * Attributes declared directly by the component.
     */
    private final static Set<AttributeInfo> ownAttributes;

    /**
     * Attributes declared by the component or its superclasses.
     */
    private final static Set<AttributeInfo> allAttributes;

    /**
     * Attributes declared by the component or its superclasses, lookup dictionary 
     * by attribute key.
     */
    private final static Map<String, AttributeInfo> allAttributesByKey;

    /**
     * Attributes declared by the component or its superclasses, lookup dictionary by 
     * attribute's field name.
     */
    private final static Map<String, AttributeInfo> allAttributesByFieldName;

    /**
     * Static initializer for internal collections.
     */
    static
    {
        attributes = new Attributes();

        final Set<AttributeInfo> ownAttrs = new HashSet<AttributeInfo>();
        ownAttrs.add(attributes.serviceURI);
        ownAttrs.add(attributes.filter);
        ownAttrs.add(attributes.dimensions);

        final Set<AttributeInfo> allAttrs = new HashSet<AttributeInfo>();
        allAttrs.add(org.carrot2.source.boss.BossImageSearchServiceDescriptor.attributes.serviceURI);
        allAttrs.add(org.carrot2.source.boss.BossImageSearchServiceDescriptor.attributes.filter);
        allAttrs.add(org.carrot2.source.boss.BossImageSearchServiceDescriptor.attributes.dimensions);
        allAttrs.add(org.carrot2.source.boss.BossSearchServiceDescriptor.attributes.appid);
        allAttrs.add(org.carrot2.source.boss.BossSearchServiceDescriptor.attributes.sites);
        allAttrs.add(org.carrot2.source.boss.BossSearchServiceDescriptor.attributes.languageAndRegion);

        allAttributes = Collections.unmodifiableSet(allAttrs);
        ownAttributes = Collections.unmodifiableSet(ownAttrs);
        
        final Map<String, AttributeInfo> allAttrsByKey = new HashMap<String, AttributeInfo>();
        final Map<String, AttributeInfo> allAttrsByFieldName = new HashMap<String, AttributeInfo>();
        for (AttributeInfo ai : allAttrs)
        {
            allAttrsByKey.put(ai.key, ai);
            allAttrsByFieldName.put(ai.fieldName, ai);
        }

        allAttributesByKey = Collections.unmodifiableMap(allAttrsByKey);
        allAttributesByFieldName = Collections.unmodifiableMap(allAttrsByFieldName);
    }

    
    /* Attribute keys. */

    /**
     * Constants for all attribute keys of the {@link org.carrot2.source.boss.BossImageSearchService} component.
     */
    public static class Keys  extends org.carrot2.source.boss.BossSearchServiceDescriptor.Keys 
    {
        protected Keys() {} 

        /** Attribute key for: {@link org.carrot2.source.boss.BossImageSearchService#serviceURI}. */
        public static final String SERVICE_URI = "BossImageSearchService.serviceURI";
        /** Attribute key for: {@link org.carrot2.source.boss.BossImageSearchService#filter}. */
        public static final String FILTER = "BossImageSearchService.filter";
        /** Attribute key for: {@link org.carrot2.source.boss.BossImageSearchService#dimensions}. */
        public static final String DIMENSIONS = "BossImageSearchService.dimensions";
    }


    /* Attribute descriptors. */

    /**
     * All attributes of the {@link org.carrot2.source.boss.BossImageSearchService} component.
     */
    public static final class Attributes
    {
        private Attributes() { /* No public instances. */ }

        /**
         *          */
        public final AttributeInfo serviceURI = 
            new AttributeInfo(
                "BossImageSearchService.serviceURI",
                "org.carrot2.source.boss.BossImageSearchService",
                "serviceURI",
                "Boss Image search service URI. Specifies the URI at which Yahoo Boss Image Search\nAPI is available. The <code>${query}</code> place holder will be replaced with\nthe URL-encoded text of the processed query.",
                "Service URI",
                "Boss Image search service URI",
                "Specifies the URI at which Yahoo Boss Image Search API is available. The <code>${query}</code> place holder will be replaced with the URL-encoded text of the processed query.",
                "Service",
                org.carrot2.util.attribute.AttributeLevel.ADVANCED,
                null
            );

        /**
         *          */
        public final AttributeInfo filter = 
            new AttributeInfo(
                "BossImageSearchService.filter",
                "org.carrot2.source.boss.BossImageSearchService",
                "filter",
                "If enabled, excludes offensive content from the results.",
                "Offensive content filter",
                "If enabled, excludes offensive content from the results",
                null,
                "Results filtering",
                org.carrot2.util.attribute.AttributeLevel.MEDIUM,
                null
            );

        /**
         *          */
        public final AttributeInfo dimensions = 
            new AttributeInfo(
                "BossImageSearchService.dimensions",
                "org.carrot2.source.boss.BossImageSearchService",
                "dimensions",
                "The size of images to fetch. Small images are generally thumbnail or icon sized.\nMedium sized images are average sized; usually not exceeding an average screen\nsize. Large images are screen size or larger.",
                "Preferred size",
                "The size of images to fetch",
                "Small images are generally thumbnail or icon sized. Medium sized images are average sized; usually not exceeding an average screen size. Large images are screen size or larger.",
                "Results filtering",
                org.carrot2.util.attribute.AttributeLevel.MEDIUM,
                null
            );


    }

    /**
     * Attribute map builder for the  {@link org.carrot2.source.boss.BossImageSearchService} component. You can use this
     * builder as a type-safe alternative to populating the attribute map using attribute keys.
     */
    public static class AttributeBuilder  extends org.carrot2.source.boss.BossSearchServiceDescriptor.AttributeBuilder 
    {
        /** The attribute map populated by this builder. */
        public final Map<String, Object> map;

        /**
         * Creates a builder backed by the provided map.
         */
        protected AttributeBuilder(Map<String, Object> map)
        {
             super(map); 
            this.map = map;
        }


        
        
        /**
         * Boss Image search service URI. Specifies the URI at which Yahoo Boss Image Search
API is available. The <code>${query}</code> place holder will be replaced with
the URL-encoded text of the processed query.
         * 
         * @see org.carrot2.source.boss.BossImageSearchService#serviceURI 
         */
        public AttributeBuilder serviceURI(java.lang.String value)
        {
            map.put("BossImageSearchService.serviceURI", value);
            return this;
        }
        
        
        
        
        
        
        
        /**
         * If enabled, excludes offensive content from the results.
         * 
         * @see org.carrot2.source.boss.BossImageSearchService#filter 
         */
        public AttributeBuilder filter(boolean value)
        {
            map.put("BossImageSearchService.filter", value);
            return this;
        }
        
        
        
        
        
        
        
        /**
         * The size of images to fetch. Small images are generally thumbnail or icon sized.
Medium sized images are average sized; usually not exceeding an average screen
size. Large images are screen size or larger.
         * 
         * @see org.carrot2.source.boss.BossImageSearchService#dimensions 
         */
        public AttributeBuilder dimensions(org.carrot2.source.boss.Dimensions value)
        {
            map.put("BossImageSearchService.dimensions", value);
            return this;
        }
        
        
        
        /**
         * The size of images to fetch. Small images are generally thumbnail or icon sized.
Medium sized images are average sized; usually not exceeding an average screen
size. Large images are screen size or larger.
         * 
         * @see org.carrot2.source.boss.BossImageSearchService#dimensions
         */
        public AttributeBuilder dimensions(Class<? extends org.carrot2.source.boss.Dimensions> clazz)
        {
            map.put("BossImageSearchService.dimensions", clazz);
            return this;
        }
        
        
        
    }

    /**
     * Creates an attribute map builder for the component. You can use this
     * builder as a type-safe alternative to populating the attribute map using attribute keys.
     * 
     * @param attributeValues An existing map which should be used to collect attribute values. 
     *        Attribute values set by this builder will be added to the provided map, overwriting
     *        previously defined mappings, if any.
     */
    public static AttributeBuilder attributeBuilder(Map<String, Object> attributeValues)
    {
        return new AttributeBuilder(attributeValues);
    }
    
    /* IBindableDescriptor */

    @Override 
    public String getPrefix()
    {
        return prefix;
    }

    @Override 
    public String getTitle()
    {
        return title;
    }
    
    @Override 
    public String getLabel()      
    { 
        return label;
    }
    
    @Override 
    public String getDescription() 
    { 
        return description; 
    }

    @Override 
    public Set<AttributeInfo> getOwnAttributes()
    { 
        return ownAttributes;
    }

    @Override 
    public Set<AttributeInfo> getAttributes()
    {
        return allAttributes;
    }

    @Override 
    public Map<String, AttributeInfo> getAttributesByKey()
    {
        return allAttributesByKey;
    }

    @Override 
    public Map<String, AttributeInfo> getAttributesByFieldName()
    {
        return allAttributesByFieldName;
    }
}
